"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const generators_1 = require("../../generators");
const http_types_1 = require("../types/http-types");
const closures = [
    /**
     * throw-http-error
     * throw a CoronadoBridge BridgeError (http error).
     * This is useful in a rules-corpus that is processing HTTP requests coming in via
     * CoreHttpInput (which uses CoronadoBridge).
     */
    generators_1.closureGenerator('throw-http-error', function (_facts, context) {
        let error = new http_types_1.ICoreHttpError(context.parameters.httpStatusCode, context.parameters.errorMessage, context.parameters.errorName);
        throw error;
    }, { required: ['httpStatusCode', 'errorMessage', 'errorName'] }),
];
exports.default = closures;
//# sourceMappingURL=error-handling-http.js.map