"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const generators_1 = require("../../generators");
const closures = [
    /**
     * error
     * throw error
     */
    generators_1.closureGenerator('throw', function (_facts, context) {
        let error = new Error(context.parameters.errorMessage);
        error.name = context.parameters.errorName;
        throw error;
    }, { required: ['errorMessage'] }),
    /**
     * message validation error
     * throw a specific error
     */
    generators_1.closureGenerator('throw-message-validation-error', function (_facts, context) {
        let error = new Error(context.parameters.errorMessage);
        error.name = 'MessageValidationError';
        throw error;
    }, { required: ['errorMessage'] }),
];
exports.default = closures;
//# sourceMappingURL=error-handling.js.map