"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CoreOutputAmqpRpc = exports.CoreOutputAmqp = exports.CoreInputScheduler = exports.CoreInputUdp = exports.CoreInputHttpResponseType = exports.CoreInputHttp = exports.CoreInputAmqp = exports.CoreErrorHandlingHttp = exports.CoreErrorHandling = exports.CoreTransformations = exports.CoreConditionals = exports.CoreClosures = void 0;
//@ts-ignore
const rules_js_1 = __importDefault(require("rules-js"));
const lodash_1 = __importDefault(require("lodash"));
__exportStar(require("./types"), exports);
__exportStar(require("./generators"), exports);
// Export Core Closures, Both as a single export and as individuals for flexibility
var index_1 = require("./core/closures/index");
Object.defineProperty(exports, "CoreClosures", { enumerable: true, get: function () { return __importDefault(index_1).default; } });
var conditionals_1 = require("./core/closures/conditionals");
Object.defineProperty(exports, "CoreConditionals", { enumerable: true, get: function () { return __importDefault(conditionals_1).default; } });
var transformations_1 = require("./core/closures/transformations");
Object.defineProperty(exports, "CoreTransformations", { enumerable: true, get: function () { return __importDefault(transformations_1).default; } });
var error_handling_1 = require("./core/closures/error-handling");
Object.defineProperty(exports, "CoreErrorHandling", { enumerable: true, get: function () { return __importDefault(error_handling_1).default; } });
var error_handling_http_1 = require("./core/closures/error-handling-http");
Object.defineProperty(exports, "CoreErrorHandlingHttp", { enumerable: true, get: function () { return __importDefault(error_handling_http_1).default; } });
// Export Core Inputs, individually since these are pick-and-choose
var amqp_input_1 = require("./core/inputs/amqp-input");
Object.defineProperty(exports, "CoreInputAmqp", { enumerable: true, get: function () { return __importDefault(amqp_input_1).default; } });
var http_input_1 = require("./core/inputs/http-input");
Object.defineProperty(exports, "CoreInputHttp", { enumerable: true, get: function () { return __importDefault(http_input_1).default; } });
Object.defineProperty(exports, "CoreInputHttpResponseType", { enumerable: true, get: function () { return http_input_1.CoreInputHttpResponseType; } });
var udp_input_1 = require("./core/inputs/udp-input");
Object.defineProperty(exports, "CoreInputUdp", { enumerable: true, get: function () { return __importDefault(udp_input_1).default; } });
var scheduler_input_1 = require("./core/inputs/scheduler-input");
Object.defineProperty(exports, "CoreInputScheduler", { enumerable: true, get: function () { return __importDefault(scheduler_input_1).default; } });
// Export Core Outputs, individually since these are pick-and-choose
var amqp_output_1 = require("./core/outputs/amqp-output");
Object.defineProperty(exports, "CoreOutputAmqp", { enumerable: true, get: function () { return __importDefault(amqp_output_1).default; } });
var amqp_rpc_output_1 = require("./core/outputs/amqp-rpc-output");
Object.defineProperty(exports, "CoreOutputAmqpRpc", { enumerable: true, get: function () { return __importDefault(amqp_rpc_output_1).default; } });
// Export Core Types that are shared by various components
// AMQP
__exportStar(require("./core/types/amqp-types"), exports);
// HTTP
__exportStar(require("./core/types/http-types"), exports);
// UDP
__exportStar(require("./core/types/udp-types"), exports);
// Scheduler
__exportStar(require("./core/types/scheduler-types"), exports);
// Export RuleHarvester
class RuleHarvester {
    /**
     * Constructor
     * This function configures the engine.
     * 1. Setup class variables
     * @params config: IRuleHarvesterConfig
     * @returns - None
     **/
    constructor(config) {
        this.fieldDereferenceChar = '^';
        this.forbiddenExtraContext = [
            'engine',
            'parameters',
            'rulesFired',
            'currentRuleFlowActivated',
            'fact',
        ];
        this.providers = config.providers;
        this.config = config;
        this.logger = config.providers.logger;
        this.extraContext = config.extraContext;
        this.ruleGroups = [];
    }
    /*****************************
     * Dereference parameters logic
     *******************************/
    /**
     * dereferenceString
     * Pulls a property from facts determined by the path in param.
     * @param facts
     * @param param
     */
    dereferenceString(facts, param) {
        return lodash_1.default.get(facts, param);
    }
    /**
     * dereferenceArray
     * Pulls an array from facts determined by the path in parameters.
     * @param facts
     * @param parameters
     */
    dereferenceArray(facts, parameters) {
        for (let i = 0; i < parameters.length; i++) {
            const param = parameters[i];
            if (lodash_1.default.isString(param) && param.charAt(0) === this.fieldDereferenceChar) {
                const key = param.substr(1);
                parameters[i] = this.dereferenceSingleValue(facts, key);
            }
            else if (!lodash_1.default.isString(param)) {
                parameters[i] = this.dereferenceSingleValue(facts, param);
            }
        }
        return parameters;
    }
    /**
     * dereferenceSingleValue
     * // TODO: Add a good comment about dereferenceSingleValue
     * @param facts
     * @param originalValue
     */
    dereferenceSingleValue(facts, originalValue) {
        let newValue = originalValue;
        if (lodash_1.default.isString(originalValue)) {
            newValue = this.dereferenceString(facts, originalValue);
        }
        else if (lodash_1.default.isArray(originalValue)) {
            newValue = this.dereferenceArray(facts, originalValue);
        }
        else if (lodash_1.default.isObject(originalValue)) {
            newValue = this.dereferenceObject(facts, originalValue);
        }
        return newValue;
    }
    /**
     * dereferenceObject
     * Used to dereference fields within an object. A field is de-referenced if the key begins with a "^"
     * Call dereferenceSingleValue which does the following
     * - If values are string then get path from facts object
     * - If value is an object then call this recursively
     * - If value is an array then call dereferenceArray
     *   - dereferenceArray uses the leading character of the value to determine if something should be de-referenced or not
     */
    dereferenceObject(facts, parameters) {
        let parameterKeys = Object.keys(parameters || {});
        for (let i = 0; i < parameterKeys.length; i++) {
            const key = parameterKeys[i];
            if (key.charAt(0) === this.fieldDereferenceChar) {
                const newKey = parameterKeys[i].substr(1);
                const originalValue = parameters[key];
                let newValue = this.dereferenceSingleValue(facts, originalValue);
                parameters[newKey] = newValue;
                delete parameters[key];
            }
        }
        return parameters;
    }
    /**
     * defaultClosureHandlerWrapper
     * This wraps the closure handler so that we log errors well
     *
     * @param name
     * @param handler
     * @param options
     */
    defaultClosureHandlerWrapper(name, handler, options) {
        return (factsAndOrRunContext, context) => __awaiter(this, void 0, void 0, function* () {
            // _.defaults overrides if a value does not already exist
            // so extraContext cannot override fields that are already defined.
            let result;
            try {
                // Parse thisRunContext out of facts
                let thisRunContext = factsAndOrRunContext === null || factsAndOrRunContext === void 0 ? void 0 : factsAndOrRunContext.thisRunContext_RuleHarvesterWrapped;
                let facts;
                const isClosureParameterDirectCall = !(factsAndOrRunContext === null || factsAndOrRunContext === void 0 ? void 0 : factsAndOrRunContext.thisRunContext_RuleHarvesterWrapped);
                // This is to fix a bug for some edge cases where it gets to this wrapper from rules-js function.process(facts,context) calls
                if (thisRunContext || factsAndOrRunContext.facts_RuleHarvesterWrapped) {
                    facts = factsAndOrRunContext === null || factsAndOrRunContext === void 0 ? void 0 : factsAndOrRunContext.facts_RuleHarvesterWrapped;
                    context.rulesFired.thisRunContext_RuleHarvesterWrapped =
                        thisRunContext;
                }
                else {
                    facts = factsAndOrRunContext;
                }
                if (!thisRunContext &&
                    context.rulesFired.thisRunContext_RuleHarvesterWrapped) {
                    thisRunContext =
                        context.rulesFired.thisRunContext_RuleHarvesterWrapped;
                }
                let contextExt = lodash_1.default.defaults(context, thisRunContext, this.extraContext);
                contextExt.closureName = name;
                contextExt.closureOptions = options;
                contextExt.parameters = this.dereferenceObject(facts, lodash_1.default.cloneDeep(contextExt.parameters));
                // let parameterKeys = Object.keys(contextExt.parameters || {});
                // for (let i = 0; i < parameterKeys.length; i++) {
                //   const key = parameterKeys[i];
                //   if (key.charAt(0) === this.fieldDereferenceChar) {
                //     const newKey = parameterKeys[i].substr(1);
                //     contextExt.parameters[newKey] = _.get(
                //       facts,
                //       contextExt.parameters[key]
                //     );
                //     delete contextExt.parameters[key];
                //   }
                // }
                result = this.config.closureHandlerWrapper // closureHandlerWrapper exist
                    ? yield this.config.closureHandlerWrapper(facts, contextExt, handler) // then call wrapper function
                    : yield handler(facts, contextExt); // else call handler directly
                // If result is undefined then skip this line
                // If this is a a direct call of a closure parameter using the closureParameters functionality then we need to skip this line
                if (result && !isClosureParameterDirectCall) {
                    result = {
                        facts_RuleHarvesterWrapped: result,
                        thisRunContext_RuleHarvesterWrapped: thisRunContext,
                    };
                }
            }
            catch (e) {
                if (this.logger) {
                    this.logger.error(`RuleHarvester.defaultClosureHandlerWrapper - Closure Name: ${name} - Error: `, e);
                }
                throw e;
            }
            return result;
        });
    }
    /**
     * closureHandlerWrapper
     * This function is a wrapper to allow us to override the context of closure functions.
     * it wraps the closure handler to supply extra context if the handler is defined.
     *
     * @param closure - The defined closure function
     * @return returns a wrapped closure function
     **/
    closureHandlerWrapper(closure) {
        let result = closure;
        if (closure.handler) {
            result = Object.assign({}, closure);
            result.handler = this.defaultClosureHandlerWrapper(closure.name, closure.handler, closure.options);
        }
        return result;
    }
    /**
     * Setup
     * This function configures the engine.
     * 1. Instantiates the engine
     * 2. Sets up the engine corpus (definitions)
     * 3. Sets of the closers (Available function closures for the corpus to work from)
     * @returns - None
     **/
    setup() {
        try {
            this.providers = this.config.providers;
            this.logger = this.config.providers.logger;
            this.extraContext = this.config.extraContext;
            this.ruleGroups = [];
            this.fieldDereferenceChar = this.config.fieldDereferenceChar || '^';
            // Make sure extraContext is not using forbidden fields
            let badContext = lodash_1.default.intersection(lodash_1.default.keys(this.extraContext), this.forbiddenExtraContext);
            if ((badContext || []).length > 0) {
                throw new Error(`One of the extraContext fields specified is forbidden and could mess with the rules engine. (${badContext.join(', ')})`);
            }
            // This will be extend the context and be passed into closure handler functions
            this.extraContext = lodash_1.default.defaults({}, this.extraContext || {}, {
                logger: this.logger,
            });
            // Instantiate rules engine
            this.engine = new rules_js_1.default();
            // Sets up closures for the provider for the rules engine
            for (let closure of this.providers.closures) {
                closure = this.closureHandlerWrapper(closure); // Wraps handler if needed
                if (!closure.handler && closure.name && closure.rules) {
                    this.engine.add(closure, closure.options);
                }
                else {
                    this.engine.closures.add(closure.name, closure.handler, closure.options);
                }
            }
            // Add corpus definitions to the engine
            for (let corpus of this.providers.corpus) {
                this.ruleGroups.push(corpus.name);
                this.engine.add({
                    name: corpus.name,
                    rules: corpus.rules,
                });
            }
        }
        catch (e) {
            if (this.logger) {
                this.logger.fatal('RuleHarvester - Error during harvester engine setup.', e);
            }
            throw e;
        }
    }
    /**
     * start the Rules Harvester.
     * Does this by...
     * 1. Does this by registering an input handler for each rule input
     * 2. Run setup input provider to initialize the rules engine
     * NOTE: Setup is purposely run after registerInput because the input provider should be able to modify the corpus
     * or configuration during setup
     *
     * @params - None
     * @returns void
     **/
    start() {
        // We bind to the applyRule to this because otherwise the calling context would
        // be from the input provider instead of the local class
        for (let ruleInput of this.providers.inputs) {
            ruleInput.registerInput(this.applyRule.bind(this), this.config);
        }
        this.setup();
    }
    /**
     * applyRule - Applies the rule to the rules engine
     * If input is not null then ..
     * 1. Process rules using the rules engine
     * 2. Send the resulting facts to the output providers
     **/
    applyRule(input, thisRunContext = null, ruleGroupOverrides = undefined) {
        return __awaiter(this, void 0, void 0, function* () {
            if (input) {
                let fact = input;
                let group = input;
                let error = null;
                try {
                    let ruleGroups = ruleGroupOverrides || this.ruleGroups;
                    ruleGroups = typeof ruleGroups === 'string' ? [ruleGroups] : ruleGroups;
                    for (group of ruleGroups) {
                        // Loop over groups and set the fact from previous
                        // rules group to the input fact for the next rules group
                        // thisRunContext + fact is passed in as a single object
                        // Our defaultClosureHandlerWrapper above will parse this out
                        // and pass facts to the original handler and extend context with thisRunContext
                        let factsAndContext;
                        ({ fact: factsAndContext } = yield this.engine.process(group, {
                            thisRunContext_RuleHarvesterWrapped: thisRunContext || {},
                            facts_RuleHarvesterWrapped: fact,
                        }));
                        fact = factsAndContext === null || factsAndContext === void 0 ? void 0 : factsAndContext.facts_RuleHarvesterWrapped; // If undefined facts then we still want to proceed
                    }
                }
                catch (e) {
                    error = e;
                    if (this.logger) {
                        this.logger.error('RuleHarvester - Error: An error occurred while processing rule', `GROUP: ${group}, fact: ${JSON.stringify(fact, null, 2)}`, e);
                    }
                }
                try {
                    // Make array of promise and wait for all to be done because we
                    // want to do these actions in parallel.
                    let proms = [];
                    for (let output of this.providers.outputs) {
                        proms.push(output.outputResult({
                            facts: fact,
                            error,
                            errorGroup: error ? group : undefined,
                            context: thisRunContext,
                        }));
                    }
                    yield Promise.all(proms);
                }
                catch (e) {
                    error = e;
                    if (this.logger) {
                        this.logger.error('RuleHarvester - Error: An error occurred while processing rule', `GROUP: ${group}, fact: ${JSON.stringify(fact, null, 2)}`, e);
                    }
                }
                // If an error occurred we want to throw it back to the input provider
                if (error) {
                    // Throw the error to the input provider
                    throw error;
                }
                else {
                    // Alternatively, if no error, we return the altered facts to the input provider also!
                    return fact;
                }
            }
        });
    }
}
exports.default = RuleHarvester;
//# sourceMappingURL=index.js.map